# This Singleton type is straight out of  http://en.wikipedia.org/wiki/Singleton_pattern

# To Use:

#class MyClass(object):

#    __metaclass__ = Singleton

 

class Singleton(type):

    def __init__(self, name, bases, dict):

        super(Singleton, self).__init__(name, bases, dict)

        self.instance = None

 

    def __call__(self, *args, **kw):

        if self.instance is None:

            self.instance = super(Singleton, self).__call__(*args, **kw)

 

        return self.instance

